
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用 Lua 完成 OAuth2 的身份验证 / iVAN</title>

    <meta name="description" content="使用 Lua 完成 OAuth2 的身份验证 本文讲的是使用 Lua 完成 OAuth2 的身份验证, 在此说明该教程将不提供详细的技术指导,教您如何使用 OpenResty + Lua 构建自己的认证层,而是讲解一下解决方案背后的处理过程. 这是一个真实的案例:moltin's API 如何依赖 OpenResty + Lua 来为所有的用户处理 oauth2 身份认证 用于验证用户的方法最初是被在运用在 PHP 框架 Laravel 所搭建的 moltin 相关的 API 当中.这就意味着在认证身份.驳回请求或验证消息从而导致高度延时的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用 Lua 完成 OAuth2 的身份验证</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>本文讲的是使用 Lua 完成 OAuth2 的身份验证，</b></p>
<p><b><br /></b></p>
<p>在此说明该教程将不提供详细的技术指导，教您如何使用 <a href="https://openresty.org/" rel="external nofollow noreferrer">OpenResty</a> + <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> 构建自己的认证层，而是讲解一下解决方案背后的处理过程。</p>
<p>这是一个真实的案例：<a href="https://moltin.com/" rel="external nofollow noreferrer">moltin</a>'s API 如何依赖 <a href="https://openresty.org/" rel="external nofollow noreferrer">OpenResty</a> + <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> 来为所有的用户处理 oauth2 身份认证</p>
<p>用于验证用户的方法最初是被在运用在 PHP 框架 <a href="https://laravel.com/" rel="external nofollow noreferrer">Laravel</a> 所搭建的 <a href="https://moltin.com/" rel="external nofollow noreferrer">moltin</a> 相关的 API 当中。这就意味着在认证身份、驳回请求或验证消息从而导致高度延时的用户请求之前需启动大量的代码。</p>
<p>我不会详细地去介绍一个PHP框架需要花多长时间才能给出一个基本响应，但如果我们将它和其他语言/框架进行比较，也许你就可以理解相关的差异。</p>
<p>以下是它所呈现的大致情景：</p>
<pre><code>...
public function filter($route, $request) {
    try {
        // Initiate the Request handler
        $this-&gt;request = new OAuthRequest;
        // Initiate the auth server with the models
        $this-&gt;server  = new OAuthResource(new OAuthSession);
        // Is it a valid token?
        if ($this-&gt;accessTokenValid() == false) {
            throw new InvalidAccessTokenException('Unable to validate access token');
        }
...
</code></pre>
<p>那么，我们决定将所有逻辑提升一层至 <a href="https://openresty.org/" rel="external nofollow noreferrer">OpenResty</a> + <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> ，便能实现如下几点：</p>
<ul>
<li>解除与Monolitic API之间的耦合关系。</li>
<li>改进认证次数和生成的访问/刷新令牌。</li>
<li>改进拒绝非法访问令牌和身份验证证书的次数。</li>
<li>改进身份验证访问令牌时的次数和重定向后再次向API发送请求的次数。</li>
</ul>
<p>我们希望并需要在请求 API 之前更好地控制每个请求，因此我们决定采用速度足够快的工具，使我们能对每个请求进行预处理，并可以十分灵活地将它们集成到我们的实际系统中。最终，我们选择了 OpenResty（一个 <a href="https://www.nginx.com/" rel="external nofollow noreferrer">Nginx</a> 的修改版本），这使得我们可以使用 <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> 来预先处理这些请求。因为 <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> 强大并且速度快，足以解决这些问题，并且 <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> 是许多大公司每天都在使用的一种受到高度认可的脚本语言。</p>
<p>我们跟随Kong背后的思想使用 <a href="https://openresty.org/" rel="external nofollow noreferrer">OpenResty</a> + <a href="http://www.lua.org/" rel="external nofollow noreferrer">Lua</a> 脚本，<a href="https://github.com/Mashape/kong" rel="external nofollow noreferrer">Kong</a> 提供了一些可插入到你的API项目中的微服务。然而，我们发现Kong仍处于一个非常初期的阶段，实际上kong正在试图提供更多我们需要的东西。因此，我们决定实现自己的验证层，使我们对它有更多的控制权。</p>
<h3>基础架构</h3>
<p><a href="https://moltin.com/" rel="external nofollow noreferrer">moltin</a> 当前的基础架构</p>
<p><a href="https://camo.githubusercontent.com/58b8a83c88626a4ba69924b65a88b9efb1a0fc25/68747470733a2f2f6d6f6c74696e2e636f6d2f66696c65732f6c617267652f363762303834633630623664306666" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NhbW8uZ2l0aHVidXNlcmNvbnRlbnQuY29tLzU4YjhhODNjODg2MjZhNGJhNjk5MjRiNjVhODhiOWVmYjFhMGZjMjUvNjg3NDc0NzA3MzNhMmYyZjZkNmY2Yzc0Njk2ZTJlNjM2ZjZkMmY2NjY5NmM2NTczMmY2YzYxNzI2NzY1MmYzNjM3NjIzMDM4MzQ2MzM2MzA2MjM2NjQzMDY2NjY=.jpg"></a></p>
<ul>
<li>OpenResty (Nginx)</li>
<li>Lua scripts</li>
<li>Caching Layer (Redis)</li>
</ul>
<h4>OpenResty</h4>
<p>这是一些配置的规则</p>
<p><a href="https://camo.githubusercontent.com/c2351315e39e99f5b886d3777f746daa9fb40f7e/68747470733a2f2f6d6f6c74696e2e636f6d2f66696c65732f6c617267652f386233353961376232626164353561" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NhbW8uZ2l0aHVidXNlcmNvbnRlbnQuY29tL2MyMzUxMzE1ZTM5ZTk5ZjViODg2ZDM3NzdmNzQ2ZGFhOWZiNDBmN2UvNjg3NDc0NzA3MzNhMmYyZjZkNmY2Yzc0Njk2ZTJlNjM2ZjZkMmY2NjY5NmM2NTczMmY2YzYxNzI2NzY1MmYzODYyMzMzNTM5NjEzNzYyMzI2MjYxNjQzNTM1NjE=.jpg"></a></p>
<p>我们设置了一些路由来处理不同用户的请求，你可以看到如下情况：</p>
<p>nginx.conf</p>
<pre><code>location ~/oauth/access_token {
    ...
}
location /v1 {
    ...
}
</code></pre>
<p>So for each of those endpoints we have to:</p>
<ul>
<li>check the authentication access token</li>
<li>get the authentication access token
<p>... location ~/oauth/access_token { content_by_lua_file "/opt/openresty/nginx/conf/oauth/get_oauth_access.lua"; ... }</p>
<p>location /v1 { access_by_lua_file "/opt/openresty/nginx/conf/oauth/check_oauth_access.lua"; ... } ...</li>
</ul>
<p>我们利用OpenResty的这两条指令 <a href="https://github.com/openresty/lua-nginx-module#content_by_lua_file" rel="external nofollow noreferrer">content_by_lua_file</a> 和<a href="https://github.com/openresty/lua-nginx-module#access_by_lua_file" rel="external nofollow noreferrer">access_by_lua_file</a>。</p>
<h4>Lua 脚本</h4>
<p>这是个不可思议的环节。我们需要编写两个lua脚本来做到这一点：</p>
<p>get_oauth_access.lua</p>
<pre><code>...
ngx.req.read_body()
args, err = ngx.req.get_post_args()

-- If we don't get any post data fail with a bad request
if not args then
    return api:respondBadRequest()
end

-- Check the grant type and pass off to the correct function
-- Or fail with a bad request
for key, val in pairs(args) do
    if key == "grant_type" then
        if val == "client_credentials" then
            ClientCredentials.new(args)
        elseif val == "password" then
            Password.new(args)
        elseif val == "implicit" then
            Implicit.new(args)
        elseif val == "refresh_token" then
            RefreshToken.new(args)
        else
            return api:respondForbidden()
        end
    end
end

return api:respondOk()
...
</code></pre>
<p>check_oauth_access.lua</p>
<pre><code>...
local authorization, err = ngx.req.get_headers()["authorization"]

-- If we have no access token forbid the beasts
if not authorization then
    return api:respondUnauthorized()
end

-- Check for the access token
local result = oauth2.getStoredAccessToken(token)

if result == false then
    return api:respondUnauthorized()
end
...
</code></pre>
<h4>缓存层</h4>
<p>在这创建并且存储访问的令牌。我们可以按照自己的意愿对其进行删除、终止或刷新。我们将Redis作为存储层，使用<a href="https://github.com/openresty/lua-resty-redis" rel="external nofollow noreferrer">openresty/lua-resty-redis</a> 把Lua连接到Redis上。</p>
<h3>资源</h3>
<p>以下是我们在创建验证层时所用到的一些与Lua相关的有趣资源。</p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b>原文发布时间为：2016年01月07日</b></p>
<p><b><br /></b></p>
<p><b>本文来自合作伙伴掘金，了解相关信息可以关注掘金网站。</b></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-02 14:25:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/request/" title="request">request</a>, <a href="https://www.iamivan.net/tag/access/" title="access">access</a>, <a href="https://www.iamivan.net/tag/redis/" title="redis">redis</a>, <a href="https://www.iamivan.net/tag/api/" title="api">api</a>, <a href="https://www.iamivan.net/tag/nginx/" title="nginx">nginx</a>, <a href="https://www.iamivan.net/tag/%e5%be%ae%e6%9c%8d%e5%8a%a1/" title="微服务">微服务</a>, <a href="https://www.iamivan.net/tag/lua/" title="lua">lua</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用 Lua 完成 OAuth2 的身份验证的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXwNmAM.html" rel="bookmark">窃取 OAuth 令牌绕过 Airbnb 身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是窃取 OAuth 令牌绕过 Airbnb 身份验证,登录过程中的CSRF与Airbnb的OAuth登录流程中的基于HTTP Referer头的开放重定向跳转漏洞相结合,可能会被用来窃取所有的Airbnb身份提供商的OAuth访问令牌,并最终确定Airbnb网站和移动应用程序的受害者.这种攻击并不依赖于特定的OAuth身份提供程序的应用程序配置缺陷(例如白名单redirect_uri 的URL中的通配符),这对所有的Airbnb的身份提供者(包括Facebook和Google)都是通用的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lpd70dM.html" rel="bookmark">如何通过SQL Server2000使用Forms 身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  摘要 ASP.NET Forms 身份验证允许用户将凭据(用户名和密码)输入到 Web Form 来标识其身份.在收到这些凭据时,Web 应用程序可以根据数据源来检查这些凭据,从而对用户进行身份验证. 本模块描述如何使用密码哈希安全地将用户凭据存储在 SQL Server 中,以及如何根据包含在 SQL Server 中的帐户数据库对用户进行身份验证. 预备知识 安全地存储用户凭据包含两个关键概念: • 存储密码摘要.出于安全性考虑,请不要将密码明文存储在数据库中.本模块描述如何创建和存储用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8g7PM.html" rel="bookmark">ASP&period;NET七大身份验证方式及解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在B/S系统开发中,经常需要使用&quot;身份验证&quot;.因为web应用程序非常特殊,和传统的C/S程序不同,默认情况下(不采用任何身份验证方式和权限控制手段),当你的程序在互联网/局域网上公开后,任何人都能够访问你的web应用程序的资源,这样很难保障应用程序安全性.通俗点来说:对于大多数的内部系统.业务支撑平台等而言,用户必须登录,否则无法访问和操作任何页面.而对于互联网(网站)而言,又有些差异,因为通常网站的大部分页面和信息都是对外公开的,只有涉及到注册用户个人信息的操作,或者网站的后台管理等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpPK4qM.html" rel="bookmark">asp&period;net里面的身份验证和授权</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天闲着无聊．想起来了ASP.NET身份验证．感觉良好．贴出下列代码:login.aspx HTML代码 &lt;%@ Page language=&quot;c#&quot; Codebehind=&quot;02Login.aspx.cs&quot; AutoEventWireup=&quot;false&quot; Inherits=&quot;身份验证._02Login&quot; %&gt;&lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0 T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9bBxmap.html" rel="bookmark">&lbrack;收藏&rsqb;使用Reporting Services中的窗体身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				services 使用 Reporting Services 中的窗体身份验证发布日期: 8/18/2004 | 更新日期: 8/18/2004Microsoft Corporation 适用范围:Microsoft SQL Server 2000 Reporting Services 摘要:了解有关 Reporting Services 安全扩展方面的知识,着重学习窗体身份验证.此外,下载和部署 Reporting Services 的窗体身份验证扩展示例. 要安装示例代码,请下载 Forms			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJor2b.html" rel="bookmark">ASP&period;Net：基于Windows的身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|window 如果将 ASP.NET 配置为使用 Windows 身份验证,则 IIS 使用配置的 IIS 身份验证机制执行用户身份验证.启用Windows身份验证的步骤如下:     (1) 配置 Web.config文件.     &lt;authentication mode=&quot;Windows&quot; /&gt;     (2) 首先启动系统的Internet 信息服务(IIS),右击网站本目录的节点,选择[属性]命令.如图12.3所示. 图12.3 启动IIS (3)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeqkAz.html" rel="bookmark">浅谈PHP&plus;MYSQL身份验证的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql 近日在为学校制做校友录时,需要身份验证,在对比之后决定采用PHP+MYSQL进行身份验证. 之前也曾考虑过用cookies或session.但是用cookies,在用户离线再上线后,只要cookies不过期,不用登录仍然可以保持在线,这对于网吧来说是个隐患.而且用户可以关闭cookies,这样身份验证就不成功.也考虑过用session,session在浏览过程中不断的将访问信息加入到session中,如果用户在网站内时间很长,浏览的页面很多,就用导致session越来越大,浏览速度降			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOgnmz.html" rel="bookmark">调用SQL SERVER数据库存储过程实现ASP用户身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|存储过程|数据|数据库 在我们编写用户身份验证程序中,很容易用ASP调用SQL语句来检索数据表中是否有条件相符的记录,然后再用ASP进行相关处理. 条条道路通罗马!当然,我们也可以用SQL SERVER数据库的存储过程来轻松实现这个功能.虽然相对而言较复杂,但其效率的提升是很明显的,因为存储过程是在数据库中已经编译好的一段程序,我们只需用ASP将其所用的各种参数正确传递就行了. 本文也主要是想通过一个简单的事例,向大家介绍一下如何在ASP中调用带参数的存储过程.希望大家能从中得到更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMAdRnb.html" rel="bookmark">asp&period;net中的身份验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net asp.net中的身份验证 我用的是基于窗体的验证,这也是最常用的,我只写一下摘要,源代码太长,但应该不影响理解代码. web.config的修改:&lt;authentication mode=&quot;Forms&quot; /&gt; 用户的登陆验证方法,:这里有两个输入控件的,一个是user_tb,用来输入用户,一个是psw_tb,用来输入密码private void Button1_Click(object sender, System.EventArgs e){//用户登陆验			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9YNvM.html" rel="bookmark" class="title">接口-手机app开发如何实现用户提现功能，使用支付宝</a>
					<div>
						问题描述 手机app开发如何实现用户提现功能,使用支付宝 大概就是首先用户使用支付宝充值到企业支付宝,app给用户生成相应金额的虚拟货币,不同用户可以使用虚拟货币相互进行交易,用户也可以通过提现功能将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrWZ1p.html" rel="bookmark" class="title">freebsd-freeBSD中不连网安装postgresql9&period;0</a>
					<div>
						问题描述 freeBSD中不连网安装postgresql9.0 在虚拟机中安装了freeBSD,安装postgresql9.0时需要使用gmake,安装gmake时需连接互联网安装,我在网上下载了gm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybj8A8p.html" rel="bookmark" class="title">ubuntu-Ubuntu本地上传项目文件夹到gitbub查看发现文件夹为空</a>
					<div>
						问题描述 Ubuntu本地上传项目文件夹到gitbub查看发现文件夹为空 echo &quot;&quot;# movies&quot;&quot; &gt;&gt; README.mdgit ini ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkvmyM.html" rel="bookmark" class="title">SuperMap 开发WebGIS的一些经验</a>
					<div>
						web SuperMap系列产品作为GIS开发平台,比较符合中国人习惯,操作也比较便利,自己做了一段时间,感觉有点郁闷,也不妨将一些经验写下来. SuperMap DeskPro中制图的一些词语: 工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrBYVM.html" rel="bookmark" class="title">seo之域名虽小 影响甚远</a>
					<div>
						对于网站seo,若要对其进行细化,那么首先就得从域名开始,域名虽小,可或许仅仅一个字符却会给网站优化带来千差万别的结果.那么如何选择一个seo化的域名呢? 一.域名长短 域名的长度往往是衡量其价值的一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx4OZb.html" rel="bookmark" class="title">巧用WPS文字2005的分栏功能进行排版</a>
					<div>
						在进行正常排版的过程中,大家经常会遇到分栏的设置需求,这样会使文档变的比较美观,而且可以结合前面几期中王老师给大家介绍的文本框间文字绕排的功能,这样一个经过比较专业排版的文档就做出来了. 好的,现在就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP5OyM.html" rel="bookmark" class="title">Oracle RMAN备份简述</a>
					<div>
						备份相关的动态性能视图及监控 1.相关视图 v$backup_files v$backup_set v$backup_piece v$backup_redolog v$backup_spfile v$ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGj58Ep.html" rel="bookmark" class="title">javascript学习笔记之函数定义</a>
					<div>
						  本文主要给大家介绍了javascript的一些函数定义方面的基础知识,包括函数声明式.函数表达式.Function 构造函数等,十分的简单实用,有需要的小伙伴可以参考下. 函数声明式 ? 1 2  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6xeBz.html" rel="bookmark" class="title">4招轻松消除电脑噪音</a>
					<div>
						电脑噪音是不是很令人不爽?特别是在深夜的时候更是烦人,没关系,只要从下面的四个方面下手.保证还你一个安安静静的电脑. 一. 消除机箱震动噪声 对于消除&quot;机箱震动&quot;噪音来说,我们可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXmrjp.html" rel="bookmark" class="title">Win8如何打开与使用磁盘清理功能</a>
					<div>
						  Win8打开与使用磁盘清理功能的方法如下: 1.进入控制面板,点击&quot;系统和安全&quot;. 2.进入系统和安全界面,点击&quot;对硬盘进行碎片整理&quot;. 3.选中驱动器,点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw2Jmb.html" rel="bookmark" class="title">IBM将收购商务流程软件公司Lombardi</a>
					<div>
						据国外http://www.aliyun.com/zixun/aggregation/31646.html&quot;&gt;媒体报道,IBM本周三宣布它已经签署了收购位于德克萨斯州奥斯汀的商务流程管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7nWvz.html" rel="bookmark" class="title">云计算技术革命必将爆发 公私混合云是未来所趋</a>
					<div>
						提到云盘,很多人并不陌生,对于企业来说,公共云盘因其有着&quot;公&quot;的特性,因此就会特别不安全,泄密事件不可避免.于是&quot;私有云&quot;就营运而生,并且近年来越来越受到业界的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwj0op.html" rel="bookmark" class="title">java  这个异常怎么弄？</a>
					<div>
						问题描述 java 这个异常怎么弄? 解决方案 要看源代码咯,找到错误的地方 解决方案二: 名字为dataSource1的bean配置有问题,你再看看 解决方案三: 数据源的配置有问题,把spring ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ3ENz.html" rel="bookmark" class="title">lftp 4&period;3&period;0发布 基于命令行的文件传输程序</a>
					<div>
						lftp是一个复杂的基于命令行的文件传输程序.支持的协议包括FTP,HTTP,SFTP和FISH.它有一个多线程的设计让同时执行多个指令或后台.它还具有镜像功能,并会重新连接并继续在断开连接时传输.另 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1Xmaz.html" rel="bookmark" class="title">JSP的实验室管理系统开发求帮助</a>
					<div>
						问题描述 构建简单专业网站:实验室管理系统-管理员子系统1.界面设计要求界面美观大方,反应网站主题,不要喧宾夺主.2.内容编排要求内容编排合理,体现个人不同的风格.管理员子系统主要有两个功能模块:管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBm1WM.html" rel="bookmark" class="title">有关控件应用问题，请大家给点建议！谢谢</a>
					<div>
						问题描述 用户输入人数,再根据人数出现相应的界面供用户输入不同的人名与相对应的性别年龄等属性.该用什么控件组合实现这功能呢?对c#控件不是很熟悉,请大家指点一下··谢谢!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkexZ1b.html" rel="bookmark" class="title">SEOER们盲目标榜的神话，存在很多的误区</a>
					<div>
						摘要: 随着博百优的迅速展开,在博百优群里与几位所谓的SEO交流过几次,常听到其自诩为SEO(搜索引擎优化)高手.SEO专家,SEO其实很简单的论调不绝于耳.被广为流传的SEO秘籍,SEO攻略让 随着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgAvwb.html" rel="bookmark" class="title">MYSQL的增删改查语句样码</a>
					<div>
						慢慢来,慢慢来.. 增: INSERT INTO person (person_id, fname, lname, gender, birth_date) VALUES (null, 'William ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqjG7p.html" rel="bookmark" class="title">MySQL 性能优化的最佳20多条经验分享&lowbar;Mysql</a>
					<div>
						当我们去设计数据库表结构,对操作数据库时(尤其是查表时的SQL语句),我们都需要注意数据操作的性能.这里,我们不会讲过多的SQL语句的优化,而只是针对MySQL这一Web应用最多的数据库.希望下面的这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAe77b.html" rel="bookmark" class="title">学习ASP&period;NET Core&comma;怎能不了解请求处理管道&lbrack;2&rsqb;&colon; 服务器在管道中的&OpenCurlyDoubleQuote;龙头&rdquo;地位</a>
					<div>
						ASP.NET Core管道由注册的服务器和一系列中间件构成.我们在上一篇中深入剖析了中间件,现在我们来了解一下服务器.服务器是ASP .NET Core管道的第一个节点,它负责完整请求的监听和接收, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4e54rb.html" rel="bookmark" class="title">从中国式的企业邮箱思路谈未来企业邮箱的竞争核心</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 据一项统计显示,中国网民平均每个人2.7个邮箱帐户,有相当一部分人甚至拥有更多的邮箱账号;同样,在国内的企业邮箱产品方面,早就已经不再是仅限于门户邮箱垄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqYEvb.html" rel="bookmark" class="title">sqlserver 转oracle 报错</a>
					<div>
						问题描述 sqlserver 转oracle 报错 [Err] ORA-32031: illegal reference of a query name in WITH clause 解决方案 查询n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdygxXz.html" rel="bookmark" class="title">《恶作剧之吻》女二号李时英公开魅惑画报&lpar;图&rpar;</a>
					<div>
						李时英李时英黑白写真李时英艳丽口红 新浪娱乐讯 北京时间8月19日上午消息,据韩国媒体报道,韩版&lt;恶作剧之吻&gt;女二号李时英继公开机场照片之后,再次公开了黑白彩妆画报. 此次与韩国某化妆品品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod1mjM.html" rel="bookmark" class="title">C&num;窗体编程中comboBox如何获取指定值</a>
					<div>
						问题描述 本人是菜鸟,刚接触C#winform,这些天公司要我改个软件,要求是这样的:就是每次插入一个设备(数据采集仪)时,要让这个设备的串口号自动显示在comboBox的第一项中,他要我用.ini文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE0L5z.html" rel="bookmark" class="title">万网独享主机Apache为Ecshop商城添加404页面的方法详解&lowbar;Linux</a>
					<div>
						标题已经说的比较清楚,只针对这一种情况,希望给予遇到同样问题的人些许启发,缩短解决问题的时间. 相关信息: 万网独享主机/Linux操作系统/Apache/Ecshop商城/404页面设置,同样在wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYlAab.html" rel="bookmark" class="title">PHP防盗链的基本思想 防盗链的设置方法&lowbar;php技巧</a>
					<div>
						盗链是指服务提供商自己不提供服务的内容,通过技术手段绕过其它有利益的最终用户界面(如广告),直接在自己的网站上向最终用户提供其它服务提供商的服务内容,骗取最终用户的浏览和点击率.受益者不提供资源或提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWy6dz.html" rel="bookmark" class="title">C语言实现图的遍历之深度优先搜索实例&lowbar;C 语言</a>
					<div>
						DFS(Depth-First-Search)深度优先搜索算法是图的遍历算法中非常常见的一类算法.分享给大家供大家参考.具体方法如下: #include &lt;iostream&gt; #inclu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8DkWb.html" rel="bookmark" class="title">不使用XMLHttpRequest实现异步加载 Iframe和script&lowbar;javascript技巧</a>
					<div>
						调用页面如下: 复制代码 代码如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnvlvp.html" rel="bookmark" class="title">java语法错误怎么改了？</a>
					<div>
						问题描述 droptable&quot;YuanGongXinXi&quot;cascadeconstraints;有错吗? 解决方案 解决方案二:连Java和SQL语法都部分,您还是我见到过的第一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baE42Pb.html" rel="bookmark" class="title">华为起诉三星启示几何 探讨知识产权在中国</a>
					<div>
						数日之间,华为再度成为舆论焦点,这一次是起诉三星侵犯通信知识产权. 知识产权诉讼,近年来随着中国企业走向世界,频频成为热词,此次之所以引发广泛关注,因为不再是传统的外国企业起诉中国企业,而是中国企业主 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
